//*************************************************************************
// Drawing the unit circle in a square and computing Pi by random numbers.
//*************************************************************************
import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.paint.Color;
import javafx.scene.shape.*;
import javafx.scene.text.Text;
import javafx.scene.text.Font;
import java.util.Random;
public class PiRandom extends Application
{
    public void start(Stage stage)
    {    
        Random point  = new Random();
        int n = 30000;     // set the number of random points
        int inside = 0;
        double x, y;       // Coordinates of a random point
        Group square = new Group();
        square.setTranslateX(300);
        square.setTranslateY(300);

        for (int i=0;i<n;i++)
        {
            x = point.nextDouble()*2-1;    // Generate a random point
            y = point.nextDouble()*2-1;
            Circle c = new Circle((int)(x*300), (int)(y*300), 2);
            if (x*x + y*y <= 1) 
            {
                c.setFill(Color.GREEN);
                inside++;
            }
            else
                c.setFill(Color.RED);
            square.getChildren().add(c);
        }
        Text pi = new Text(0,595,"Pi = " + String.valueOf (4*(float)inside/n));
        pi.setFont(new Font(30));
        Group root = new Group (square,pi);
        Scene scene = new Scene(root, 600, 600, Color.LIGHTBLUE);
        stage.setTitle("Pi by random numbers");
        stage.setScene(scene);
        stage.show();
    }

    public static void main(String args[])
    {
        launch(args);
    }

}
